/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#include <RTRelayPort.h>
#include <RTActor.h>

int RTRelayPort::followIn( RTBindingEnd & end,
			   RTActor      * owner,
			   int            id,
			   int            index,
			   int            size,
			   RTActorRef   * importer )
{
    if( index < 0 || size <= index )
    {
	// bad replication index
    }
    else if( importer != (RTActorRef *)0 )
    {
	if( _importers != (RTActorRef **)0 )
	{
	    int direct      = directUse( owner->getReference(), id );
	    int indirectUse = size - direct;

	    for( int i = 0; i < indirectUse; ++i )
		if( _importers[ i ] == importer && index-- == 0 )
		    return owner->_followInV( end, id, direct + i );
	}
    }
    else if( index < directUse( owner->getReference(), id ) )
    {
	return owner->_followInV( end, id, index );
    }

    return 0;
}
