/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#ifndef __RTActorSlot_inl__
#define __RTActorSlot_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActorSlot_h__
#include <RTActorSlot.h>
#endif

RTS_INLINE int RTSmallOptional::supports( int size )
{
    return size < threshold;
}

RTS_INLINE void RTSmallOptional::insert( int p, int n )
{
    _actor = (RTActor *)
	     ( ( p << prev_shift ) + ( n << next_shift ) + 1 ); //lint !e701
}

RTS_INLINE void RTSmallOptional::prev( int p )
{
    int links = (int)(long)_actor;

    links &= ~ ( link_mask << prev_shift );
    links |=             p << prev_shift; //lint !e701

    _actor = (RTActor *)links;
}

RTS_INLINE int RTSmallOptional::prev( void ) const
{
    return ( (int)(long)_actor >> prev_shift ) & link_mask; //lint !e702
}

RTS_INLINE void RTSmallOptional::next( int n )
{
    int links = (int)(long)_actor;

    links &= ~ ( link_mask << next_shift );
    links |=             n << next_shift; //lint !e701

    _actor = (RTActor *)links;
}

RTS_INLINE int RTSmallOptional::next( void ) const
{
    return ( (int)(long)_actor >> next_shift ) & link_mask; //lint !e702
}

RTS_INLINE int RTSmallOptional::inuse( void ) const
{
    return ( 1 & (int)(long)_actor ) == 0;
}

#endif // __RTActorSlot_inl__
