/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#ifdef PRAGMA
#pragma implementation "RTMain.h"
#pragma implementation "RTMain.inl"
#pragma implementation "RTSystemDescriptor.h"
#endif

#include <RTMain.h>
#include <RTOse.h>
#include <RTSystemDescriptor.h>

static int ( * main_thread_func )( void );

OS_PROCESS( main_thread )
{
    (void)(*main_thread_func)();

    kill_proc( current_process() );
}

int RTMain::execute( void )
{
    // Initialize address of function to be executed. We don't need to worry
    // about concurrency here because it will only ever have this value.
    main_thread_func = &RTMain::mainLine;

    // Create the dynamic thread that will become the main thread.
    PROCESS proc = create_process( OS_PRI_PROC,
				   (char *)"main_thread",
				   main_thread,
				   _system->mainStackSize,
				   _system->mainPriority,
				   (OSTIME)0,
				   (PROCESS)0,
				   (OS_redir_entry *)0,
				   (OSVECTOR)0,
				   (OSUSER)0 );

    ose_start( proc );

    return 0;
}
