/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#include <RTMain.h>
#include <taskLib.h>

extern "C"
{

#if PERFORM_CTOR_DTOR
    typedef void ( * VoidFunction )( void );

    extern VoidFunction _ctors[];
    extern VoidFunction _dtors[];
#endif

int rtsMain( char * a01, char * a02, char * a03, char * a04,
	     char * a05, char * a06, char * a07, char * a08,
	     char * a09, char * a10, char * a11, char * a12,
	     char * a13, char * a14, char * a15, char * a16,
	     char * a17, char * a18, char * a19, char * a20 )
{
#if PERFORM_CTOR_DTOR
    // construct/initialize globals

    for( VoidFunction * ctor = _ctors; *ctor != (VoidFunction)0; ++ctor )
	(*ctor)();
#endif

    int          argc;
    const char * argv[ 22 ];

    argv[  0 ] = "MicroRTS";
    argv[  1 ] = a01; argv[  2 ] = a02; argv[  3 ] = a03; argv[  4 ] = a04;
    argv[  5 ] = a05; argv[  6 ] = a06; argv[  7 ] = a07; argv[  8 ] = a08;
    argv[  9 ] = a09; argv[ 10 ] = a10; argv[ 11 ] = a11; argv[ 12 ] = a12;
    argv[ 13 ] = a13; argv[ 14 ] = a14; argv[ 15 ] = a15; argv[ 16 ] = a16;
    argv[ 17 ] = a17; argv[ 18 ] = a18; argv[ 19 ] = a19; argv[ 20 ] = a20;
    argv[ 21 ] = (const char *)0;

    for( argc = 0; argv[ ++argc ] != (const char *)0; )
    {
	// search for first null
    }

    int result = RTMain::entryPoint( argc, argv );

#if PERFORM_CTOR_DTOR
    // destruct globals

    for( VoidFunction * dtor = _dtors; *dtor != (VoidFunction)0; ++dtor )
	(*dtor)();
#endif

    return result;
}

} // extern "C"
