/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#ifdef PRAGMA
#pragma implementation "RTMain.h"
#pragma implementation "RTMain.inl"
#pragma implementation "RTSystemDescriptor.h"
#endif

#include <RTMain.h>

#if USE_WINCE_RTCONSOLE
#include <RTDiag.h>
#include <RTSystemDescriptor.h>
#include <RTWinCE.h>
#endif

int RTMain::execute( void )
{
#if ! USE_WINCE_RTCONSOLE
    return mainLine();
#else
    HANDLE handle;
    DWORD  tid;

    if( (handle = CreateThread( (LPSECURITY_ATTRIBUTES)0,
				(DWORD)_system->mainStackSize,
				(LPTHREAD_START_ROUTINE)mainLine,
				(LPVOID)0,
				(DWORD)CREATE_SUSPENDED, &tid )) == (HANDLE)0 )
	RTDiag::panic( "execute(create)" );
#if TARGET_WINCE >= 300 && ! defined( _WIN32_WCE_EMULATION )
    else if( ! CeSetThreadPriority( handle, _system->mainPriority ) )
#else
    else if( ! SetThreadPriority( handle, THREAD_PRIORITY_NORMAL
					  + _system->mainPriority ) )
#endif
	RTDiag::panic( "RTThread(priority)" );
    else if( ResumeThread( handle ) != (DWORD)1 )
	RTDiag::panic( "execute(resume)" );
    else
	RTWinCE::soleInstance->mainThread = handle;

    return 0;
#endif // USE_WINCE_RTCONSOLE
}
