/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#include <RTPubl/Encoding.h>
#include <RTPubl/FielDesc.h>
#include <RTPubl/ObjClass.h>

int RTEncoding_putFields( RTEncoding                   * this,
			  const void                   * value,
			  const struct _RTObject_class * record,
			  int                          * first )
{
    int                       count = record->_num_fields;
    const RTFieldDescriptor * field = record->_fields;

    if( record->_super == (const RTObject_class *)0 )
    {
	/* we have no base type */
    }
    else if( ! RTEncoding_putFields( this, value, record->_super, first ) )
    {
	return 0; /* failure encoding the base type */
    }

    for( ; --count >= 0; ++field )
    {
	if( field->type == (const RTObject_class *)0 )
	    continue; /* skip fields of unknown types */

	if( *first )
	    *first = 0;
	else if( ! RTEncoding_putFieldSeparator( this ) )
	    return 0;

	if( ! RTEncoding_putName( this, field->name ) )
	    return 0;

	if( ! RTFieldDescriptor_encode( field, value, this ) )
	    return 0;
    }

    return 1;
}
