/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#include <RTPriv/RTstdio.h>
#include <RTPriv/uITRON3.h>
#include <RTPubl/Main.h>
#include <RTPubl/SystDesc.h>
#include <RTPubl/ThrdDesc.h>

static void * main_thread_func( INT arg )
{
    (void)arg; /* It is used. */

    (void)RTMain_mainLine();

    ext_tsk();

    return (void *)0;
}

int RTMain_runThread( void )
{
    const RTSystemDescriptor * system = RTMain_system();
    ID                         main_task_id;
    T_CTSK                     main_task_packet;

    main_task_packet.exinf   =  (VP)0;
    main_task_packet.tskatr  =      TA_HLNG;
    main_task_packet.task    =  (FP)main_thread_func;
    main_task_packet.itskpri = (PRI)system->constThreads[ 0 ].Priority;
    main_task_packet.stksz   =      system->constThreads[ 0 ].StackSize;

    if( cre_tsk( main_task_id = RTnextTaskId++, &main_task_packet ) != E_OK )
    {
#if STDIO_ENABLED
	RTStdio_panic( "cre_tsk" );
#endif
    }

    if( sta_tsk( main_task_id, 0 ) != E_OK )
    {
#if STDIO_ENABLED
	RTStdio_panic( "sta_tsk" );
#endif
    }

    return 0;
}
